﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.Diagnostics;
using Infragistics.Documents.Excel;
using Infragistics.Controls.Grids;
using System.IO;


namespace XamGridExport
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }
    }

    public class XamGridCommands
    {

        private Workbook ExportWorkbook(XamGrid grid)
        {
            // Create a Workbook object and add a sheet in it.
            Workbook workbook = new Workbook();
            Worksheet worksheet = workbook.Worksheets.Add("Sheet1");
            workbook.SetCurrentFormat(WorkbookFormat.Excel2007);

            // Export xamGrid data to the created Workbook object
            XamGridExcelExporter exporter = new XamGridExcelExporter();
            exporter.Export(grid, workbook);

            return workbook;
        }

        public ICommand ExportCommnad
        {
            get
            {

                return new RelayCommand(new Action<object>((sender) =>
                {
                    SaveFileDialog saveDialog = new SaveFileDialog();
                    saveDialog.DefaultExt = "xlsx";
                    saveDialog.Filter = "Excel Workbook (.xlsx)|*.xlsx";

                    if (saveDialog.ShowDialog().Value)
                    {
                        try
                        {
                            Stream stream = saveDialog.OpenFile();

                            Workbook exportedWorkbook = this.ExportWorkbook(sender as XamGrid);
                            exportedWorkbook.Save(stream);
                            stream.Close();
                        }
                        catch (Exception exc)
                        {
                            MessageBox.Show(exc.Message);
                        }
                    }
                }));
            }
        }
    }

    public class RelayCommand : ICommand
    {
        #region Fields

        readonly Action<object> _execute;
        readonly Predicate<object> _canExecute;

        #endregion // Fields

        #region Constructors

        public RelayCommand(Action<object> execute)
            : this(execute, null)
        {
        }

        public RelayCommand(Action<object> execute, Predicate<object> canExecute)
        {
            if (execute == null)
                throw new ArgumentNullException("execute");

            _execute = execute;
            _canExecute = canExecute;
        }
        #endregion // Constructors

        #region ICommand Members

        [DebuggerStepThrough]
        public bool CanExecute(object parameter)
        {
            return _canExecute == null ? true : _canExecute(parameter);
        }       

        public void Execute(object parameter)
        {
            _execute(parameter);
        }

        #endregion // ICommand Members


        public event EventHandler CanExecuteChanged;
    }

     public class Element
    {
        public Element(string elNumber, string description)
        {
            this.description = description;
            this.elNumber = elNumber;
        }
        private string elNumber;
        public string ElementNumber
        {
            get { return elNumber; }
            set { elNumber = value; }
        }

        private string description;
        public string Description
        {
            get { return description; }
            set { description = value; }
        }
    
    }
     public class DeviceElements : ObservableCollection<Element>
     {
         public ObservableCollection<Element> GetCollection()
         {
             ObservableCollection<Element> data = new ObservableCollection<Element>
             {
                new Element("dataitem 1","dataitem1description"),
                new Element("dataitem 2","dataitem2description"),
                new Element("dataitem 3","dataitem3description"),
                new Element("dataitem 4","dataitem4description"),
                new Element("dataitem 5","dataitem5description"),
                new Element("dataitem 6","dataitem6description"),
             };
             return data;
         }

         public ObservableCollection<Element> GetSimpleCollection
         {
             get
             {
                 return GetCollection();
             }
         }
     }
}
